﻿Imports System.Windows.Forms
Imports System.Drawing
Imports System.Globalization

Namespace OperationNS
    Public Class OperationControl
        Inherits UserControl
        ' Methods
        Private Sub New()
            Me.InitializeComponent()
        End Sub

        Protected Overrides Sub Dispose(ByVal disposing As Boolean)
            If (disposing AndAlso (Not Me.components Is Nothing)) Then
                Me.components.Dispose()
            End If
            MyBase.Dispose(disposing)
        End Sub

        Public Shared Function GetInstance() As OperationControl
            If (OperationControl.instance Is Nothing) Then
                OperationControl.instance = New OperationControl
            End If
            Return OperationControl.instance
        End Function

        Public Sub Increment(ByVal [step] As Integer)
            Me.StatusProgress.Increment([step])
        End Sub

        Private Sub InitializeComponent()
            Me.StatusProgress = New System.Windows.Forms.ProgressBar
            Me.StatusText = New System.Windows.Forms.Label
            Me.SuspendLayout()
            '
            'StatusProgress
            '
            Me.StatusProgress.ForeColor = System.Drawing.Color.FromArgb(CType(CType(0, Byte), Integer), CType(CType(192, Byte), Integer), CType(CType(0, Byte), Integer))
            Me.StatusProgress.Location = New System.Drawing.Point(5, 5)
            Me.StatusProgress.Name = "StatusProgress"
            Me.StatusProgress.Size = New System.Drawing.Size(165, 23)
            Me.StatusProgress.Step = 1
            Me.StatusProgress.Style = System.Windows.Forms.ProgressBarStyle.Continuous
            Me.StatusProgress.TabIndex = 0
            '
            'StatusText
            '
            Me.StatusText.BackColor = System.Drawing.SystemColors.ButtonFace
            Me.StatusText.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
            Me.StatusText.Font = New System.Drawing.Font("Microsoft Sans Serif", 12.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
            Me.StatusText.ForeColor = System.Drawing.Color.Red
            Me.StatusText.Location = New System.Drawing.Point(173, 5)
            Me.StatusText.Name = "StatusText"
            Me.StatusText.Size = New System.Drawing.Size(353, 23)
            Me.StatusText.TabIndex = 1
            Me.StatusText.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
            '
            'OperationControl
            '
            Me.Controls.Add(Me.StatusText)
            Me.Controls.Add(Me.StatusProgress)
            Me.Name = "OperationControl"
            Me.Size = New System.Drawing.Size(614, 34)
            Me.ResumeLayout(False)

        End Sub

        Public Sub Start(ByVal operationName As String, ByVal startingMaximum As Integer)
            Me.StatusText.Text = String.Format(CultureInfo.CurrentCulture, "Starting '{0}' ...", New Object() {operationName})
            Me.operationName = operationName
            Me.Maximum = startingMaximum
            Me.operationStart = DateTime.Now
        End Sub

        Public Sub [Stop]()
            Dim duration As TimeSpan = DirectCast((DateTime.Now - Me.operationStart), TimeSpan)
            Me.StatusText.Text = String.Format(CultureInfo.CurrentCulture, "'{0}' took {1} seconds", New Object() {Me.operationName, duration.TotalSeconds})
            Me.StatusProgress.Maximum = 0
        End Sub


        ' Properties
        Public Property Maximum() As Integer
            Get
                Return Me.StatusProgress.Maximum
            End Get
            Set(ByVal value As Integer)
                Me.StatusProgress.Maximum = value
            End Set
        End Property


        ' Fields
        Private components As System.ComponentModel.Container = Nothing
        Private Shared instance As OperationControl = Nothing
        Private operationName As String
        Private operationStart As DateTime
        Private StatusProgress As ProgressBar
        Private StatusText As Label
    End Class
End Namespace
