﻿Imports System.Resources
Imports System.IO
Imports Operation.OperationNS
Imports Person.PersonInformationNS
Imports System.Reflection
Imports System.Text.RegularExpressions

Namespace PeopleNS
	Public Class People
		Public Overridable Function GetNames(ByVal resourceManager As ResourceManager, _
																						ByVal fileName As String) As ArrayList
			Dim names As New ArrayList

			' Open the file we are interested in
			Using reader As StringReader = _
							New StringReader(resourceManager.GetString(fileName))

				' Read out the names and add them to the ArrayList
				Dim name As String = reader.ReadLine

				Do While (Not name Is Nothing)
					names.Add(name.Trim)

					name = reader.ReadLine
				Loop

			End Using

			' Return the results
			Return names
		End Function

		Public Function GetPeople(ByVal number As Integer) As ArrayList
			' Set up the progress bar
			Dim instance As OperationControl = OperationControl.GetInstance
			instance.Maximum = (instance.Maximum + number)


			Dim people As New ArrayList
			Dim i As Integer = 1
			Do While (i <= number)
				' Fetch the full name
				Dim fullNames As ArrayList = GetNames(Me.resourceManager, "fullNames")
				Dim fullName = CStr(fullNames(i))

				' Fetch the company name
				Dim companyNames As ArrayList = GetNames(Me.resourceManager, "companyNames")
				Dim companyName = CStr(companyNames(i))

				' Create a new PersonInformation object and add to array
				people.Add(New PersonInformation(fullName, companyName))
				OperationControl.GetInstance.Increment(1)

				i += 1
			Loop
			Return people
		End Function

		Public Function FindPersonInformation(ByVal findFirstName As String) _
																														As PersonInformation

			' Create a new PersonCollection to iterate over PersonInformations
			Dim personInfos As PersonCollection = New PersonCollection

			Dim i As Integer = 0
			While i < personInfos.Count
				' Retrieve next PersonInfo
				Dim info As PersonInformation = personInfos(i)

				' Parse the first name from the full name
				Dim first As String = ParseFirstName(info.FullName)

				' Is this the name we're looking for?
				If first = findFirstName Then
					Return info
				End If

				i += 1
			End While

			'For Each info As PersonInformation In personInfos
			'    ' Parse the first name from the full name
			'    Dim first As String = ParseFirstName(info.FullName)

			'    ' Is this the name we're looking for?
			'    If first = findFirstName Then
			'        Return info
			'    End If
			'Next

			' Couldn't find it, so return Nothing
			Return Nothing
		End Function

		Public Function ParseFirstName(ByVal fullName As String) As String
			Dim match As Match = Regex.Match(fullName, "(\w+), (\w+)")
			If match.Success Then
				Dim first As String = match.Groups(2).Value

				Return first
			End If

			Return String.Empty
		End Function

		' Fields
		Private resourceManager As ResourceManager = New ResourceManager("People.People", Assembly.GetExecutingAssembly)

	End Class
End Namespace
