﻿Imports System.Globalization
Imports System.IO
Imports System.Drawing
Imports System.Configuration
Imports Operation.OperationNS
Imports Person.PersonInformationNS
Imports People.PeopleNS

Public Class Form2
    ' Methods
    Public Sub New()
        Me.InitializeComponent()
    End Sub

    Private Function ExportData() As String
        Dim data As String = ""
        Dim item As ListViewItem
        For Each item In Me.peopleList.Items
            data = (data & item.SubItems.Item(0).Text)
            data = (data & ",")
            data = (data & item.SubItems.Item(1).Text)
            data = (data & ChrW(13) & ChrW(10))
            OperationControl.GetInstance.Increment(1)
        Next
        Return data
    End Function

    Private Sub ExportToExcel_Click(ByVal sender As Object, ByVal e As EventArgs) Handles Find.Click
        OperationControl.GetInstance.Start("Export To Excel", Me.numPeople)
        Dim data As String = Me.ExportData
        Dim outputFile As String = String.Format(CultureInfo.CurrentCulture, "{0}\{1}", New Object() {Path.GetTempPath, Me.outputFileName})
        Dim writer As New StreamWriter(outputFile)
        writer.WriteLine(data)
        writer.Close()
        OperationControl.GetInstance.Stop()
        Dim exportProcess As New Process
        exportProcess.StartInfo.FileName = outputFile
        exportProcess.StartInfo.UseShellExecute = True
        exportProcess.Start()
    End Sub



    Private Sub GetPeopleButton_Click(ByVal sender As Object, ByVal e As EventArgs) Handles GetPeopleButton.Click
        OperationControl.GetInstance.Start("Get People", Me.numPeople)
        Dim people As New People.PeopleNS.People
        Me.peopleList.Items.Clear()
        Dim person As PersonInformation
        For Each person In people.GetPeople(Me.numPeople)
            Dim personItem As New ListViewItem(New String() {person.FullName, person.Employer})
            personItem.ForeColor = Color.FromName("Blue")
            Me.peopleList.Items.Add(personItem)
            OperationControl.GetInstance.Increment(1)
        Next
        OperationControl.GetInstance.Stop()
    End Sub


    Private Sub InitializeComponent()
        Me.GetPeopleButton = New System.Windows.Forms.Button
        Me.groupBox1 = New System.Windows.Forms.GroupBox
        Me.Find = New System.Windows.Forms.Button
        Me.peopleList = New System.Windows.Forms.ListView
        Me.fullName = New System.Windows.Forms.ColumnHeader
        Me._companyName = New System.Windows.Forms.ColumnHeader
        Me.groupBox1.SuspendLayout()
        Me.SuspendLayout()
        '
        'GetPeopleButton
        '
        Me.GetPeopleButton.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.GetPeopleButton.ForeColor = System.Drawing.SystemColors.ControlText
        Me.GetPeopleButton.Location = New System.Drawing.Point(6, 376)
        Me.GetPeopleButton.Margin = New System.Windows.Forms.Padding(4, 3, 4, 3)
        Me.GetPeopleButton.Name = "GetPeopleButton"
        Me.GetPeopleButton.Size = New System.Drawing.Size(124, 23)
        Me.GetPeopleButton.TabIndex = 0
        Me.GetPeopleButton.Text = "Get People"
        '
        'groupBox1
        '
        Me.groupBox1.Controls.Add(Me.Find)
        Me.groupBox1.Controls.Add(Me.peopleList)
        Me.groupBox1.Controls.Add(Me.GetPeopleButton)
        Me.groupBox1.ForeColor = System.Drawing.SystemColors.ActiveCaption
        Me.groupBox1.Location = New System.Drawing.Point(12, 7)
        Me.groupBox1.Margin = New System.Windows.Forms.Padding(4, 3, 4, 3)
        Me.groupBox1.Name = "groupBox1"
        Me.groupBox1.Padding = New System.Windows.Forms.Padding(4, 3, 4, 3)
        Me.groupBox1.Size = New System.Drawing.Size(632, 407)
        Me.groupBox1.TabIndex = 4
        Me.groupBox1.TabStop = False
        Me.groupBox1.Text = "People"
        '
        'Find
        '
        Me.Find.ForeColor = System.Drawing.SystemColors.ControlText
        Me.Find.Location = New System.Drawing.Point(140, 376)
        Me.Find.Margin = New System.Windows.Forms.Padding(4, 3, 4, 3)
        Me.Find.Name = "Find"
        Me.Find.Size = New System.Drawing.Size(124, 23)
        Me.Find.TabIndex = 5
        Me.Find.Text = "Find"
        '
        'peopleList
        '
        Me.peopleList.Columns.AddRange(New System.Windows.Forms.ColumnHeader() {Me.fullName, Me._companyName})
        Me.peopleList.FullRowSelect = True
        Me.peopleList.GridLines = True
        Me.peopleList.Location = New System.Drawing.Point(6, 21)
        Me.peopleList.Margin = New System.Windows.Forms.Padding(4, 3, 4, 3)
        Me.peopleList.Name = "peopleList"
        Me.peopleList.Size = New System.Drawing.Size(614, 349)
        Me.peopleList.TabIndex = 4
        Me.peopleList.UseCompatibleStateImageBehavior = False
        Me.peopleList.View = System.Windows.Forms.View.Details
        '
        'fullName
        '
        Me.fullName.Text = "Full Name"
        Me.fullName.Width = 200
        '
        '_companyName
        '
        Me._companyName.Text = "Company Name"
        Me._companyName.Width = 310
        '
        'OperationControl1
        '
        Me.OperationControl1 = OperationControl.GetInstance
        Me.OperationControl1.Location = New System.Drawing.Point(14, 417)
        Me.OperationControl1.Maximum = 100
        Me.OperationControl1.Name = "OperationControl1"
        Me.OperationControl1.Size = New System.Drawing.Size(614, 34)
        Me.OperationControl1.TabIndex = 5
        '
        'Form2
        '
        Me.AutoScaleDimensions = New System.Drawing.SizeF(6.0!, 13.0!)
        Me.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font
        Me.ClientSize = New System.Drawing.Size(655, 451)
        Me.Controls.Add(Me.OperationControl1)
        Me.Controls.Add(Me.groupBox1)
        Me.Margin = New System.Windows.Forms.Padding(4, 3, 4, 3)
        Me.MaximizeBox = False
        Me.MinimizeBox = False
        Me.Name = "Form2"
        Me.Text = "PeopleTrax"
        Me.groupBox1.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub

    ' Fields
    Private _companyName As ColumnHeader
    Private WithEvents Find As Button
    Private fullName As ColumnHeader
    Private WithEvents GetPeopleButton As Button
    Private groupBox1 As GroupBox
    Private ReadOnly numPeople As Integer = Integer.Parse(ConfigurationManager.AppSettings.Get("numPeople"), CultureInfo.CurrentCulture)
    Private ReadOnly outputFileName As String = ConfigurationManager.AppSettings.Get("outputFileName")
    Private peopleList As ListView
End Class